Setting Live ‘Keywords For Site’ Tasks

Note that Google Ads Keywords Data API is based on the latest version of the Google Ads API that has replaced legacy Google AdWords API. If you’re using DataForSEO Google AdWords API, you need to upgrade to DataForSEO Google Ads API.
‌‌
This endpoint will provide you with a list of keywords relevant to the specified domain along with their bids, search volumes for the last month, search volume trends for the last year (for estimating search volume dynamics), and competition levels.

Note: you can send no more than 12 requests per minute per account using Google Ads Live endpoints.

Historical data is available for 4 years.

checked POST
Pricing

Your account will be charged for each request.
The cost can be calculated on the Pricing page.

All POST data should be sent in the JSON format (UTF-8 encoding). The task setting is done using the POST method. When setting a task, you should send all task parameters in the task array of the generic POST array. You can send up to 2000 API calls per minute, each Live API call can contain only one task. Visit DataForSEO Help Center to get practical tips for request handling depending on your Keyword Data API payload volume.

You can get up to 2000 keyword suggestions with all essential keyword data in response to one request. Your account will be charged for each request, no matter what number of keywords you receive in the result.

Below you will find a detailed description of the fields you can use for setting a task.

Description of the fields for setting a task:

Field nameTypeDescription
targetstring

domain or page
required field
the domain name of the target website or the url of the target page;
note: to obtain keywords for the target website, use the target_type parameter

target_typestring

search keywords for site or for url
optional field
possible values: site, page;
default value: page;
if set to site, keywords will be provided for the entire site;
if set to page, keywords will be provided for the specified webpage

location_namestring

full name of search engine location
optional field
if you do not indicate the location, you will receive worldwide results, i.e., for all available locations;
if you use this field, you don't need to specify location_code or location_coordinate
you can receive the list of available locations of the search engine with their location_name by making a separate request to https://api.dataforseo.com/v3/keywords_data/google_ads/locations
example:
London,England,United Kingdom

location_codeinteger

search engine location code
optional field
if you do not indicate the location, you will receive worldwide results, i.e., for all available locations;
if you use this field, you don't need to specify location_name or location_coordinate;
you can receive the list of available locations of the search engines with their location_code by making a separate request to https://api.dataforseo.com/v3/keywords_data/google_ads/locations
example:
2840

location_coordinatestring

GPS coordinates of a location
optional field
if you do not indicate the location, you will receive worldwide results, i.e., for all available locations;
if you use this field, you don't need to specify location_name or location_code;
location_coordinate parameter should be specified in the "latitude,longitude" format;
the data will be provided for the country the specified coordinates belong to;
example:
52.6178549,-155.352142

language_namestring

full name of search engine language
optional field
you can receive the list of available languages of the search engine with their language_name by making a separate request to https://api.dataforseo.com/v3/keywords_data/google_ads/languages
example:
English

language_codestring

search engine language code
optional field
you can receive the list of available languages of the search engine with their language_code by making a separate request to https://api.dataforseo.com/v3/keywords_data/google_ads/languages
example:
en

search_partnersboolean

include Google search partners
optional field
if you specify true, the results will be delivered for owned, operated, and syndicated networks across Google and partner sites that host Google search;
default value: false - results are returned for Google search sites

date_fromstring

starting date of the time range
optional field
date format: "yyyy-mm-dd"
minimal value: 4 years from the current date
by default, data is returned for the past 12 months;
Note: the indicated date cannot be greater than that specified in date_to and/or yesterday's date;if Status endpoint returns false in the actual_data field, date_from can be set to the month before last and prior;
if Status endpoint returns true in the actual_data field, date_from can be set to the last month and prior

date_tostring

ending date of the time range
optional field
Note: the indicated date cannot be greater than yesterday's date;
if you don't specify this field, yesterday's date will be used by default
date format: "yyyy-mm-dd"
example:
"2022-11-30"

include_adult_keywordsboolean

include keywords associated with adult content
optional field
if set to true, adult keywords will be included in the response
default value: false
note that the API may return no data for such keywords due to Google Ads restrictions

sort_bystring

results sorting parameters
optional field
Use these parameters to sort the results by relevance, search_volume, competition_index, low_top_of_page_bid, or high_top_of_page_bid in descending order
default value: relevance

tagstring

user-defined task identifier
optional field
the character limit is 255
you can use this parameter to identify the task and match it with the result
you will find the specified tag value in the data object of the response


‌‌
As a response of the API server, you will receive JSON-encoded data containing a tasks array with the information specific to the set tasks.

Description of the fields in the result array:

Field nameTypeDescription
versionstring

the current version of the API

status_codeinteger

general status code
you can find the full list of the response codes here
Note: we strongly recommend designing a necessary system for handling related exceptional or error conditions

status_messagestring

general informational message
you can find the full list of general informational messages here

timestring

execution time, seconds

costfloat

total tasks cost, USD

tasks_countinteger

the number of tasks in the tasks array

tasks_errorinteger

the number of tasks in the tasks array returned with an error

tasksarray

array of tasks

    idstring

task identifier
unique task identifier in our system in the UUID format

    status_codeinteger

status code of the task
generated by DataForSEO; can be within the following range: 10000-60000
you can find the full list of response codes here

    status_messagestring

informational message of the task
you can find the full list of general informational messages here

    timestring

execution time, seconds

    costfloat

cost of the task, USD

    result_countinteger

number of elements in the result array

    patharray

URL path

    dataobject

contains the same parameters that you specified in the POST request

    resultarray

array of results

        keywordstring

keyword in a POST array

        location_codeinteger

location code in a POST array
if there is no data, the value is_nulln

        language_codestring

language code in a POST array
if there is no data, the value is_nulln

        search_partnersboolean

include Google search partners
the value you specified when setting the task
if true, the results are returned for owned, operated, and syndicated networks across Google and partner sites that host Google search;
if false, the results are returned for Google search sites only

        competitionstring

competition
represents the relative level of competition associated with the given keyword in paid SERP only
possible values: LOW, MEDIUM, HIGH
if competition level is unknown, the value is null;
learn more about the metric in this help center article

        competition_indexinteger

competition index
the competition index for the query indicating how competitive ad placement is for the keyword
can take values from 0 to 100
the level of competition from 0 to 100 is determined by the number of ad slots filled divided by the total number of ad slots available
if not enough data is available, the value is null;
learn more about the metric in this help center article

        search_volumeinteger

monthly average search volume rate
represents the (approximate) number of searches for the given keyword idea either on google.com or google.com and partners, depending on the user’s targeting
if there is no data, the value is null

        low_top_of_page_bidfloat

minimum bid for the ad to be displayed at the top of the first page
indicates the value greater than about 20% of the lowest bids for which ads were displayed (based on Google Ads statistics for advertisers)
the value may differ depending on the location specified in a POST request

        high_top_of_page_bidfloat

maximum bid for the ad to be displayed at the top of the first page
indicates the value greater than about 80% of the lowest bids for which ads were displayed (based on Google Ads statistics for advertisers)
the value may differ depending on the location specified in a POST request

        cpcfloat

cost per click
indicates the amount paid (USD) for each click on the ad displayed for a given keyword

        monthly_searchesarray

monthly searches
represents the (approximate) number of searches on this keyword idea (as available for the past twelve months), targeted to the specified geographic locations
if there is no data, the value is null

            yearinteger

year

            monthinteger

month

            search_volumeinteger

monthly average search volume rate

        keyword_annotationsobject

the annotations for the keyword

            conceptsarray

the list of concepts for the keyword

                namestring

the concept name for the keyword in the concept_group

                concept_groupobject

the concept group of the concept details

                    namestring

the concept group name

                    typestring

the concept group type


‌‌

Instead of ‘login’ and ‘password’ use your credentials from https://app.dataforseo.com/api-access

# Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access 
login="login" 
password="password" 
cred="$(printf ${login}:${password} | base64)" 
curl --location --request POST "https://api.dataforseo.com/v3/keywords_data/google_ads/keywords_for_site/live" 
--header "Authorization: Basic ${cred}"  
--header "Content-Type: application/json" 
--data-raw '[
    {
        "location_code": 2840,
        "target": "dataforseo.com"

    }
]'
<?php
// You can download this file from here https://cdn.dataforseo.com/v3/examples/php/php_RestClient.zip
require('RestClient.php');
$api_url = 'https://api.dataforseo.com/';
try {
	// Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
	$client = new RestClient($api_url, null, 'login', 'password');
} catch (RestClientException $e) {
	echo "n";
	print "HTTP code: {$e->getHttpCode()}n";
	print "Error code: {$e->getCode()}n";
	print "Message: {$e->getMessage()}n";
	print  $e->getTraceAsString();
	echo "n";
	exit();
}
$post_array = array();
// simple way to set a task
$post_array[] = array(
	"location_name" => "United States",
	"target" => "dataforseo.com"
);
try {
	// POST /v3/keywords_data/google_ads/keywords_for_site/live
	// the full list of possible parameters is available in documentation
	$result = $client->post('/v3/keywords_data/google_ads/keywords_for_site/live', $post_array);
	print_r($result);
	// do something with post result
} catch (RestClientException $e) {
	echo "n";
	print "HTTP code: {$e->getHttpCode()}n";
	print "Error code: {$e->getCode()}n";
	print "Message: {$e->getMessage()}n";
	print  $e->getTraceAsString();
	echo "n";
}
$client = null;
?>
const post_array = [];

post_array.push({
  "location_name": "United States",
  "target": "dataforseo.com"
});

const axios = require('axios');

axios({
  method: 'post',
  url: 'https://api.dataforseo.com/v3/keywords_data/google_ads/keywords_for_site/live',
  auth: {
    username: 'login',
    password: 'password'
  },
  data: post_array,
  headers: {
    'content-type': 'application/json'
  }
}).then(function (response) {
  var result = response['data']['tasks'];
  // Result data
  console.log(result);
}).catch(function (error) {
  console.log(error);
});
from client import RestClient
# You can download this file from here https://cdn.dataforseo.com/v3/examples/python/python_Client.zip
client = RestClient("login", "password")
post_data = dict()
# simple way to set a task
post_data[len(post_data)] = dict(
    location_name="United States",
    target="dataforseo.com"
)
# POST /v3/keywords_data/google_ads/keywords_for_site/live
# the full list of possible parameters is available in documentation
response = client.post("/v3/keywords_data/google_ads/keywords_for_site/live", post_data)
# you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
if response["status_code"] == 20000:
    print(response)
    # do something with result
else:
    print("error. Code: %d Message: %s" % (response["status_code"], response["status_message"]))
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;

namespace DataForSeoDemos
{
    public static partial class Demos
    {
        public static async Task keywords_data_keywords_for_site_live()
        {
            var httpClient = new HttpClient
            {
                BaseAddress = new Uri("https://api.dataforseo.com/"),
                // Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
                DefaultRequestHeaders = { Authorization = new AuthenticationHeaderValue("Basic", Convert.ToBase64String(Encoding.ASCII.GetBytes("login:password"))) }
            };
            var postData = new List<object>();
            postData.Add(new
            {
                location_name = "United States",
                target = "dataforseo.com"
            });
            // POST /v3/keywords_data/google_ads/keywords_for_site/live
            // the full list of possible parameters is available in documentation
            var taskPostResponse = await httpClient.PostAsync("/v3/keywords_data/google_ads/keywords_for_site/live", new StringContent(JsonConvert.SerializeObject(postData)));
            var result = JsonConvert.DeserializeObject<dynamic&gt(await taskPostResponse.Content.ReadAsStringAsync());
            // you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
            if (result.status_code == 20000)
            {
                // do something with result
                Console.WriteLine(result);
            }
            else
                Console.WriteLine($"error. Code: {result.status_code} Message: {result.status_message}");
        }
    }
}

The above command returns JSON structured like this:

{
  "version": "0.1.20210917",
  "status_code": 20000,
  "status_message": "Ok.",
  "time": "3.6321 sec.",
  "cost": 0.075,
  "tasks_count": 1,
  "tasks_error": 0,
  "tasks": [
    {
      "id": "10281603-2806-0091-0000-c0ff06ae8fdb",
      "status_code": 20000,
      "status_message": "Ok.",
      "time": "3.5644 sec.",
      "cost": 0.075,
      "result_count": 699,
      "path": [
        "v3",
        "keywords_data",
        "google_ads",
        "keywords_for_site",
        "live"
      ],
      "data": {
        "api": "keywords_data",
        "function": "keywords_for_site",
        "se": "google_ads",
        "target": "dataforseo.com",
        "location_code": 2840,
        "search_partners": "true"
      },
      "result": [
        {
          "keyword": "free seo tools",
          "location_code": 2840,
          "language_code": null,
          "search_partners": true,
          "competition": "MEDIUM",
          "competition_index": 50,
          "search_volume": 12100,
          "low_top_of_page_bid": 77.67,
          "high_top_of_page_bid": 381.54,
          "cpc": 3.94,
          "monthly_searches": [
            {
              "year": 2020,
              "month": 10,
              "search_volume": 4400
            },
            {
              "year": 2020,
              "month": 11,
              "search_volume": 3600
            },
            {
              "year": 2020,
              "month": 12,
              "search_volume": 2900
            },
            {
              "year": 2021,
              "month": 1,
              "search_volume": 3600
            },
            {
              "year": 2021,
              "month": 2,
              "search_volume": 90500
            },
            {
              "year": 2021,
              "month": 3,
              "search_volume": 3600
            },
            {
              "year": 2021,
              "month": 4,
              "search_volume": 4400
            },
            {
              "year": 2021,
              "month": 5,
              "search_volume": 2900
            },
            {
              "year": 2021,
              "month": 6,
              "search_volume": 2900
            },
            {
              "year": 2021,
              "month": 7,
              "search_volume": 2900
            },
            {
              "year": 2021,
              "month": 8,
              "search_volume": 2900
            },
            {
              "year": 2021,
              "month": 9,
              "search_volume": 2400
            }
          ],
          "keyword_annotations": {
            "concepts": [
              {
                "name": "seo software free",
                "concept_group": {
                  "name": "Others",
                  "type": null
                }
              },
              {
                "name": "Non-Brands",
                "concept_group": {
                  "name": "Non-Brands",
                  "type": "NON_BRAND"
                }
              }
            ]
          }
        },
        {
          "keyword": "dataforseo",
          "location_code": 2840,
          "language_code": null,
          "search_partners": true,
          "competition": "LOW",
          "competition_index": 12,
          "search_volume": 110,
          "low_top_of_page_bid": 104.34,
          "high_top_of_page_bid": 264.96,
          "cpc": 3.94,
          "monthly_searches": [
            {
              "year": 2020,
              "month": 10,
              "search_volume": 170
            },
            {
              "year": 2020,
              "month": 11,
              "search_volume": 90
            },
            {
              "year": 2020,
              "month": 12,
              "search_volume": 90
            },
            {
              "year": 2021,
              "month": 1,
              "search_volume": 110
            },
            {
              "year": 2021,
              "month": 2,
              "search_volume": 90
            },
            {
              "year": 2021,
              "month": 3,
              "search_volume": 90
            },
            {
              "year": 2021,
              "month": 4,
              "search_volume": 90
            },
            {
              "year": 2021,
              "month": 5,
              "search_volume": 110
            },
            {
              "year": 2021,
              "month": 6,
              "search_volume": 110
            },
            {
              "year": 2021,
              "month": 7,
              "search_volume": 110
            },
            {
              "year": 2021,
              "month": 8,
              "search_volume": 170
            },
            {
              "year": 2021,
              "month": 9,
              "search_volume": 170
            }
          ],
          "keyword_annotations": {
            "concepts": [
              {
                "name": "data seo",
                "concept_group": {
                  "name": "Others",
                  "type": null
                }
              },
              {
                "name": "Non-Brands",
                "concept_group": {
                  "name": "Non-Brands",
                  "type": "NON_BRAND"
                }
              }
            ]
          }
        },
        {
          "keyword": "best seo tools",
          "location_code": 2840,
          "language_code": null,
          "search_partners": true,
          "competition": "MEDIUM",
          "competition_index": 41,
          "search_volume": 2900,
          "low_top_of_page_bid": 130.17,
          "high_top_of_page_bid": 780.74,
          "cpc": 3.94,
          "monthly_searches": [
            {
              "year": 2020,
              "month": 10,
              "search_volume": 8100
            },
            {
              "year": 2020,
              "month": 11,
              "search_volume": 2400
            },
            {
              "year": 2020,
              "month": 12,
              "search_volume": 4400
            },
            {
              "year": 2021,
              "month": 1,
              "search_volume": 2400
            },
            {
              "year": 2021,
              "month": 2,
              "search_volume": 1900
            },
            {
              "year": 2021,
              "month": 3,
              "search_volume": 2400
            },
            {
              "year": 2021,
              "month": 4,
              "search_volume": 2900
            },
            {
              "year": 2021,
              "month": 5,
              "search_volume": 1900
            },
            {
              "year": 2021,
              "month": 6,
              "search_volume": 1900
            },
            {
              "year": 2021,
              "month": 7,
              "search_volume": 1600
            },
            {
              "year": 2021,
              "month": 8,
              "search_volume": 2400
            },
            {
              "year": 2021,
              "month": 9,
              "search_volume": 1900
            }
          ],
          "keyword_annotations": {
            "concepts": [
              {
                "name": "Non-Brands",
                "concept_group": {
                  "name": "Non-Brands",
                  "type": "NON_BRAND"
                }
              }
            ]
          }
        },
        {
          "keyword": "top seo tools",
          "location_code": 2840,
          "language_code": null,
          "search_partners": true,
          "competition": "LOW",
          "competition_index": 24,
          "search_volume": 1300,
          "low_top_of_page_bid": 113.83,
          "high_top_of_page_bid": 481.14,
          "cpc": 3.94,
          "monthly_searches": [
            {
              "year": 2020,
              "month": 10,
              "search_volume": 9900
            },
            {
              "year": 2020,
              "month": 11,
              "search_volume": 590
            },
            {
              "year": 2020,
              "month": 12,
              "search_volume": 2400
            },
            {
              "year": 2021,
              "month": 1,
              "search_volume": 720
            },
            {
              "year": 2021,
              "month": 2,
              "search_volume": 590
            },
            {
              "year": 2021,
              "month": 3,
              "search_volume": 590
            },
            {
              "year": 2021,
              "month": 4,
              "search_volume": 590
            },
            {
              "year": 2021,
              "month": 5,
              "search_volume": 720
            },
            {
              "year": 2021,
              "month": 6,
              "search_volume": 480
            },
            {
              "year": 2021,
              "month": 7,
              "search_volume": 390
            },
            {
              "year": 2021,
              "month": 8,
              "search_volume": 480
            },
            {
              "year": 2021,
              "month": 9,
              "search_volume": 320
            }
          ],
          "keyword_annotations": {
            "concepts": [
              {
                "name": "Non-Brands",
                "concept_group": {
                  "name": "Non-Brands",
                  "type": "NON_BRAND"
                }
              }
            ]
          }
        },
        {
          "keyword": "seo tools list",
          "location_code": 2840,
          "language_code": null,
          "search_partners": true,
          "competition": "LOW",
          "competition_index": 18,
          "search_volume": 260,
          "low_top_of_page_bid": 148.09,
          "high_top_of_page_bid": 474.29,
          "cpc": 3.94,
          "monthly_searches": [
            {
              "year": 2020,
              "month": 10,
              "search_volume": 390
            },
            {
              "year": 2020,
              "month": 11,
              "search_volume": 320
            },
            {
              "year": 2020,
              "month": 12,
              "search_volume": 260
            },
            {
              "year": 2021,
              "month": 1,
              "search_volume": 390
            },
            {
              "year": 2021,
              "month": 2,
              "search_volume": 260
            },
            {
              "year": 2021,
              "month": 3,
              "search_volume": 260
            },
            {
              "year": 2021,
              "month": 4,
              "search_volume": 260
            },
            {
              "year": 2021,
              "month": 5,
              "search_volume": 390
            },
            {
              "year": 2021,
              "month": 6,
              "search_volume": 140
            },
            {
              "year": 2021,
              "month": 7,
              "search_volume": 110
            },
            {
              "year": 2021,
              "month": 8,
              "search_volume": 140
            },
            {
              "year": 2021,
              "month": 9,
              "search_volume": 170
            }
          ],
          "keyword_annotations": {
            "concepts": [
              {
                "name": "seo software free",
                "concept_group": {
                  "name": "Others",
                  "type": null
                }
              },
              {
                "name": "Non-Brands",
                "concept_group": {
                  "name": "Non-Brands",
                  "type": "NON_BRAND"
                }
              }
            ]
          }
        }
      ]
    }
  ]
}